diff -burN boost-1.30.2/boost/iterator_adaptors.hpp boost-1.30.2.cl-preprocessor-fix/boost/iterator_adaptors.hpp
--- boost-1.30.2/boost/iterator_adaptors.hpp	2002-12-27 17:51:52.000000000 +0100
+++ boost-1.30.2.cl-preprocessor-fix/boost/iterator_adaptors.hpp	2003-09-19 17:04:16.000000000 +0200
@@ -1115,29 +1115,42 @@
 # endif
 }
 
-template <class OuterIterator,      // Mutable or Immutable, does not matter
-          class Value
-#if !BOOST_WORKAROUND(BOOST_MSVC, <= 1300)
-                = BOOST_ARG_DEPENDENT_TYPENAME detail::traits_of_value_type<
-                        OuterIterator>::value_type
-#endif
-          , class Reference
-#if !BOOST_WORKAROUND(BOOST_MSVC, <= 1300)
-                = BOOST_ARG_DEPENDENT_TYPENAME detail::traits_of_value_type<
-                        OuterIterator>::reference
-#else
-                = Value &
-#endif
-          , class Category = BOOST_ARG_DEPENDENT_TYPENAME boost::detail::iterator_traits<
-                        OuterIterator>::iterator_category
-          , class Pointer
+
 #if !BOOST_WORKAROUND(BOOST_MSVC, <= 1300)
-                = BOOST_ARG_DEPENDENT_TYPENAME detail::traits_of_value_type<
-                        OuterIterator>::pointer
+
+template <class OuterIterator,      // Mutable or Immutable, does not matter
+          class Value = BOOST_ARG_DEPENDENT_TYPENAME detail::traits_of_value_type<OuterIterator>::value_type
+          , class Reference = BOOST_ARG_DEPENDENT_TYPENAME detail::traits_of_value_type<OuterIterator>::reference
+          , class Category = BOOST_ARG_DEPENDENT_TYPENAME boost::detail::iterator_traits<OuterIterator>::iterator_category
+          , class Pointer = BOOST_ARG_DEPENDENT_TYPENAME detail::traits_of_value_type<OuterIterator>::pointer >
+struct indirect_iterator_generator
+{
+    typedef iterator_adaptor<OuterIterator,
+        indirect_iterator_policies,Value,Reference,Pointer,Category> type;
+};
+  
+template <class OuterIterator,      // Mutable or Immutable, does not matter
+          class Value = BOOST_ARG_DEPENDENT_TYPENAME detail::traits_of_value_type<OuterIterator>::value_type
+          , class Reference = BOOST_ARG_DEPENDENT_TYPENAME detail::traits_of_value_type<OuterIterator>::reference
+          , class ConstReference = Value const&
+          , class Category = BOOST_ARG_DEPENDENT_TYPENAME boost::detail::iterator_traits<OuterIterator>::iterator_category
+          , class Pointer = BOOST_ARG_DEPENDENT_TYPENAME detail::traits_of_value_type<OuterIterator>::pointer
+          , class ConstPointer = Value const* >
+struct indirect_iterator_pair_generator
+{
+  typedef typename indirect_iterator_generator<OuterIterator,
+    Value, Reference,Category,Pointer>::type iterator;
+  typedef typename indirect_iterator_generator<OuterIterator,
+    Value, ConstReference,Category,ConstPointer>::type const_iterator;
+};
+    
 #else
-                = Value*
-#endif
-         >
+
+template <class OuterIterator,      // Mutable or Immutable, does not matter
+          class Value
+          , class Reference= Value &
+          , class Category = BOOST_ARG_DEPENDENT_TYPENAME boost::detail::iterator_traits<OuterIterator>::iterator_category
+          , class Pointer = Value* >
 struct indirect_iterator_generator
 {
     typedef iterator_adaptor<OuterIterator,
@@ -1146,29 +1159,11 @@
 
 template <class OuterIterator,      // Mutable or Immutable, does not matter
           class Value
-#if !BOOST_WORKAROUND(BOOST_MSVC, <= 1300)
-                = BOOST_ARG_DEPENDENT_TYPENAME detail::traits_of_value_type<
-                        OuterIterator>::value_type
-#endif
-          , class Reference
-#if !BOOST_WORKAROUND(BOOST_MSVC, <= 1300)
-                = BOOST_ARG_DEPENDENT_TYPENAME detail::traits_of_value_type<
-                        OuterIterator>::reference
-#else
-                = Value &
-#endif
+		  , class Reference= Value &
           , class ConstReference = Value const&
-          , class Category = BOOST_ARG_DEPENDENT_TYPENAME boost::detail::iterator_traits<
-                OuterIterator>::iterator_category
-          , class Pointer
-#if !BOOST_WORKAROUND(BOOST_MSVC, <= 1300)
-                = BOOST_ARG_DEPENDENT_TYPENAME detail::traits_of_value_type<
-                        OuterIterator>::pointer
-#else
-                = Value*
-#endif
-          , class ConstPointer = Value const*
-           >
+          , class Category = BOOST_ARG_DEPENDENT_TYPENAME boost::detail::iterator_traits<OuterIterator>::iterator_category
+          , class Pointer = Value*
+          , class ConstPointer = Value const* >
 struct indirect_iterator_pair_generator
 {
   typedef typename indirect_iterator_generator<OuterIterator,
@@ -1177,6 +1172,9 @@
     Value, ConstReference,Category,ConstPointer>::type const_iterator;
 };
 
+#endif
+
+
 #if !BOOST_WORKAROUND(BOOST_MSVC, <= 1300)
 template <class OuterIterator>
 inline typename indirect_iterator_generator<OuterIterator>::type
diff -burN boost-1.30.2/boost/regex/v3/instances.hpp boost-1.30.2.cl-preprocessor-fix/boost/regex/v3/instances.hpp
--- boost-1.30.2/boost/regex/v3/instances.hpp	2002-11-07 13:50:29.000000000 +0100
+++ boost-1.30.2.cl-preprocessor-fix/boost/regex/v3/instances.hpp	2003-09-19 17:05:05.000000000 +0200
@@ -73,10 +73,10 @@
 
 //template class BOOST_REGEX_DECL regex_traits< BOOST_REGEX_CHAR_T >;
 template class BOOST_REGEX_DECL reg_expression< BOOST_REGEX_CHAR_T >;
-template class BOOST_REGEX_DECL re_detail::match_results_base<BOOST_REGEX_CHAR_T const*, BOOST_DEFAULT_ALLOCATOR(re_detail::def_alloc_param_traits<BOOST_REGEX_CHAR_T const*>::type)>;
-template class BOOST_REGEX_DECL re_detail::match_results_base<std::basic_string<BOOST_REGEX_CHAR_T>::const_iterator, BOOST_DEFAULT_ALLOCATOR(re_detail::def_alloc_param_traits<std::basic_string<BOOST_REGEX_CHAR_T>::const_iterator>::type)>;
-template class BOOST_REGEX_DECL match_results<BOOST_REGEX_CHAR_T const*, BOOST_DEFAULT_ALLOCATOR(re_detail::def_alloc_param_traits<BOOST_REGEX_CHAR_T const*>::type)>;
-template class BOOST_REGEX_DECL match_results<std::basic_string<BOOST_REGEX_CHAR_T>::const_iterator, BOOST_DEFAULT_ALLOCATOR(re_detail::def_alloc_param_traits<std::basic_string<BOOST_REGEX_CHAR_T>::const_iterator>::type)>;
+template class BOOST_REGEX_DECL re_detail::match_results_base<BOOST_REGEX_CHAR_T const*, BOOST_DEFAULT_ALLOCATOR(re_detail::def_alloc_param_traits<BOOST_REGEX_CHAR_T const*>::type) >;
+template class BOOST_REGEX_DECL re_detail::match_results_base<std::basic_string<BOOST_REGEX_CHAR_T>::const_iterator, BOOST_DEFAULT_ALLOCATOR(re_detail::def_alloc_param_traits<std::basic_string<BOOST_REGEX_CHAR_T>::const_iterator>::type) >;
+template class BOOST_REGEX_DECL match_results<BOOST_REGEX_CHAR_T const*, BOOST_DEFAULT_ALLOCATOR(re_detail::def_alloc_param_traits<BOOST_REGEX_CHAR_T const*>::type) >;
+template class BOOST_REGEX_DECL match_results<std::basic_string<BOOST_REGEX_CHAR_T>::const_iterator, BOOST_DEFAULT_ALLOCATOR(re_detail::def_alloc_param_traits<std::basic_string<BOOST_REGEX_CHAR_T>::const_iterator>::type) >;
 
 
 #pragma warning(pop)
@@ -119,8 +119,8 @@
 template void BOOST_REGEX_CALL reg_expression<BOOST_REGEX_CHAR_T>::fixup_apply(re_detail::re_syntax_base* b, unsigned cbraces);
 template void BOOST_REGEX_CALL reg_expression<BOOST_REGEX_CHAR_T>::move_offsets(re_detail::re_syntax_base* j, unsigned size);
 template re_detail::re_syntax_base* BOOST_REGEX_CALL reg_expression<BOOST_REGEX_CHAR_T>::compile_set(const BOOST_REGEX_CHAR_T*& first, const BOOST_REGEX_CHAR_T* last);
-template re_detail::re_syntax_base* BOOST_REGEX_CALL reg_expression<BOOST_REGEX_CHAR_T>::compile_set_aux(re_detail::jstack<reg_expression<BOOST_REGEX_CHAR_T>::traits_string_type, BOOST_DEFAULT_ALLOCATOR(BOOST_REGEX_CHAR_T)>& singles, re_detail::jstack<reg_expression<BOOST_REGEX_CHAR_T>::traits_string_type, BOOST_DEFAULT_ALLOCATOR(BOOST_REGEX_CHAR_T)>& ranges, re_detail::jstack<boost::uint_fast32_t, BOOST_DEFAULT_ALLOCATOR(BOOST_REGEX_CHAR_T)>& classes, re_detail::jstack<reg_expression<BOOST_REGEX_CHAR_T>::traits_string_type, BOOST_DEFAULT_ALLOCATOR(BOOST_REGEX_CHAR_T)>& equivalents, bool isnot, const re_detail::_narrow_type&);
-template re_detail::re_syntax_base* BOOST_REGEX_CALL reg_expression<BOOST_REGEX_CHAR_T>::compile_set_aux(re_detail::jstack<reg_expression<BOOST_REGEX_CHAR_T>::traits_string_type, BOOST_DEFAULT_ALLOCATOR(BOOST_REGEX_CHAR_T)>& singles, re_detail::jstack<reg_expression<BOOST_REGEX_CHAR_T>::traits_string_type, BOOST_DEFAULT_ALLOCATOR(BOOST_REGEX_CHAR_T)>& ranges, re_detail::jstack<boost::uint_fast32_t, BOOST_DEFAULT_ALLOCATOR(BOOST_REGEX_CHAR_T)>& classes, re_detail::jstack<reg_expression<BOOST_REGEX_CHAR_T>::traits_string_type, BOOST_DEFAULT_ALLOCATOR(BOOST_REGEX_CHAR_T)>& equivalents, bool isnot, const re_detail::_wide_type&);
+template re_detail::re_syntax_base* BOOST_REGEX_CALL reg_expression<BOOST_REGEX_CHAR_T>::compile_set_aux(re_detail::jstack<reg_expression<BOOST_REGEX_CHAR_T>::traits_string_type, BOOST_DEFAULT_ALLOCATOR(BOOST_REGEX_CHAR_T) >& singles, re_detail::jstack<reg_expression<BOOST_REGEX_CHAR_T>::traits_string_type, BOOST_DEFAULT_ALLOCATOR(BOOST_REGEX_CHAR_T) >& ranges, re_detail::jstack<boost::uint_fast32_t, BOOST_DEFAULT_ALLOCATOR(BOOST_REGEX_CHAR_T) >& classes, re_detail::jstack<reg_expression<BOOST_REGEX_CHAR_T>::traits_string_type, BOOST_DEFAULT_ALLOCATOR(BOOST_REGEX_CHAR_T) >& equivalents, bool isnot, const re_detail::_narrow_type&);
+template re_detail::re_syntax_base* BOOST_REGEX_CALL reg_expression<BOOST_REGEX_CHAR_T>::compile_set_aux(re_detail::jstack<reg_expression<BOOST_REGEX_CHAR_T>::traits_string_type, BOOST_DEFAULT_ALLOCATOR(BOOST_REGEX_CHAR_T) >& singles, re_detail::jstack<reg_expression<BOOST_REGEX_CHAR_T>::traits_string_type, BOOST_DEFAULT_ALLOCATOR(BOOST_REGEX_CHAR_T) >& ranges, re_detail::jstack<boost::uint_fast32_t, BOOST_DEFAULT_ALLOCATOR(BOOST_REGEX_CHAR_T) >& classes, re_detail::jstack<reg_expression<BOOST_REGEX_CHAR_T>::traits_string_type, BOOST_DEFAULT_ALLOCATOR(BOOST_REGEX_CHAR_T) >& equivalents, bool isnot, const re_detail::_wide_type&);
 template re_detail::re_syntax_base* BOOST_REGEX_CALL reg_expression<BOOST_REGEX_CHAR_T>::compile_set_simple(re_detail::re_syntax_base* dat, unsigned long cls, bool isnot);
 template unsigned int BOOST_REGEX_CALL reg_expression<BOOST_REGEX_CHAR_T>::parse_inner_set(const BOOST_REGEX_CHAR_T*& first, const BOOST_REGEX_CHAR_T* last);
 template re_detail::re_syntax_base* BOOST_REGEX_CALL reg_expression<BOOST_REGEX_CHAR_T>::add_simple(re_detail::re_syntax_base* dat, re_detail::syntax_element_type type, unsigned int size);
